unit Main;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  PrintSM, SMRAuto, Grids, DBGrids, Db, DBTables, ComCtrls;

type
  TfrmMain = class(TForm)
    pcMode: TPageControl;
    tsDataGrid: TTabSheet;
    tsPreview: TTabSheet;
    tblCountry: TTable;
    dSrcCountry: TDataSource;
    gridCountry: TDBGrid;
    SMPrintData1: TSMPrintData;
    procedure pcModeChange(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
    { Private declarations }
    procedure CloseEmbeddedPreviewControl;
  public
    { Public declarations }
  end;

var
  frmMain: TfrmMain;

implementation

{$R *.DFM}

procedure TfrmMain.CloseEmbeddedPreviewControl;
begin
  {close existing preview control}
  if tsPreview.ControlCount > 0 then
    PostMessage(TWinControl(tsPreview.Controls[0]).Handle, WM_CLOSE, 0, 0)
end;

procedure TfrmMain.pcModeChange(Sender: TObject);
begin
  if (pcMode.ActivePage = tsPreview) then
    SMPrintData1.PreviewParentedControl(tsPreview)
  else
    CloseEmbeddedPreviewControl
end;

procedure TfrmMain.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  CloseEmbeddedPreviewControl;
end;

end.
